#! CRADDON 1
#! NAME Prisoner's Dilemma
#! DESCRIPTION Escape &lt;br /&gt; tags in HTML-enabled multi-line fields.<br>written by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a><br><a href="http://www.wwddfd.com/">plushpuffin's perl garden</a><br><img src="http://www.wwddfd.com/update/update.cgi?item=cra_prisoner&version=1">
#! VERSION build 1
#! DOC 1

#
# Escape <br /> tags in HTML-enabled multi-line fields.
# by plushpuffin
# plushpuffin@wwddfd.com
# http://www.wwddfd.com/
#

# Will compile & work with the following:
#use strict;
#use vars qw(%Subs %in %CConfig);

my $addon = new Addon(q~Prisoner's Dilemma~);
$addon->checkBuild(20);

my $BRescapeSubmit = << 'END_CODE';
	foreach my $fn (@fieldDB) {
		# Go through the list of fields.
		if ($fieldDB{$fn}->{'Newlines'} && $up > $fieldDB{$fn}->{'SubmitPerm'} && ! $fieldDB{$fn}->{'DisableHTML'}) {
			$in{$fn} =~ s~\G(.*?)(<BRESCAPE>)(.*?)(\Z|</BRESCAPE>)~$1 . $2 . killbr($3) . $4~geis;
		}
	}
END_CODE

my $BRunescapeModify = << 'END_CODE';
	foreach my $fn (@fieldDB) {
		# Go through the list of fields.
		if ($fieldDB{$fn}->{'Newlines'} && $up > $fieldDB{$fn}->{'ModifyPerm'} && ! $fieldDB{$fn}->{'DisableHTML'}) {
			$$fn =~ s~\G(.*?)(<BRESCAPE>)(.*?)(\Z|</BRESCAPE>)~$1 . $2 . unkillbr($3) . $4~geis;
		}
	}
END_CODE

my $BRescapeModifySave = << 'END_CODE';
	foreach my $fn (@fieldDB) {
		# Go through the list of fields.
		if ($fieldDB{$fn}->{'Newlines'} && $up > $fieldDB{$fn}->{'ModifyPerm'} && ! $fieldDB{$fn}->{'DisableHTML'}) {
			$in{$fn} =~ s~\G(.*?)(<BRESCAPE>)(.*?)(\Z|</BRESCAPE>)~$1 . $2 . killbr($3) . $4~geis;
		}
	}
END_CODE

$Subs{killbr} = << 'END_SUB';
sub killbr {
	( $_ = $_[0] ) =~ s~\n~<ebr />~gi;
	return $_;
}
END_SUB

$Subs{unkillbr} = << 'END_SUB';
sub unkillbr {
	( $_ = $_[0] ) =~ s~<ebr[\s/]*>~\n~gi;
	return $_;
}
END_SUB

$addon->hook('SaveNews_Pre', \$BRescapeSubmit, 10);
$addon->hook('ModifyNews_Edit_TopRow', \$BRunescapeModify, 10);
$addon->hook('ModifyNews_EditSave_Permissions', \$BRescapeModifySave, 10);

1;

__END__

=head1 Prisoner's Dilemma

=head2 SETUP

After enabling the addon, you may submit or modify news, using <BRESCAPE> and </BRESCAPE> in any HTML-enabled multi-line field, where desired. Any text in between the opening and closing BRESCAPE tags will NOT be terminated with a <br /> tag. Instead it will have an <ebr /> tag, which should remain hidden and unobtrusive in most/all browsers, as it is an unknown tag.

=head2 ABOUT THE AUTHOR

=over 4

=item *

name: plushpuffin

=item *

email: plushpuffin@wwddfd.com

=item *

site: http://www.wwddfd.com/

=back